#ifndef WBVIEW_H
#define WBVIEW_H	1


#include <exec/exec.h>
#include <intuition/intuition.h>
#include <workbench/startup.h>
#include <workbench/workbench.h>
#include <graphics/gfx.h>
#include <graphics/displayinfo.h>
#include <datatypes/pictureclass.h>
#include <libraries/asl.h>



#define	DEFAULT_WINWIDTH	300
#define	DEFAULT_WINHEIGHT	300
#define	DEFAULT_PENSHARING	MITEM_ECONOMICAL
#define	DEFAULT_REMAPPING	MITEM_HAM_MEDIUM

#define	MIN_WINWIDTH		100
#define	MIN_WINHEIGHT		100

#define THRESHOLD_SPAREMODE	20


#define	ASPM_NO_CARE			0
#define	ASPM_KEEP_PIC			1
#define	ASPM_KEEP_SCREEN		2
#define	ASPM_KEEP_ALL			3


#define PATHNAMESIZE	400
#define FILENAMESIZE	32
#define FORMATNAMESIZE	20
#define WINDOWNAMESIZE	FILENAMESIZE+FORMATNAMESIZE

struct ChunkyImage
{
	UBYTE *chunky;
	ULONG *palette;
	DOUBLE aspect;
	UWORD width,height;	/*,depth;*/
	UWORD colormode;
	UWORD bytewidth;
	ULONG displayID;
	UWORD aspectmode;
};


struct DisplayEntity
{
	struct ChunkyImage *ci;
	struct PenShareMap *psm;
	BOOL converted;
};



struct WBViewSettings
{
	UWORD	pensharing;
	UWORD	remapping;
};



struct WBView
{
	struct Window *window;
	struct AppWindow *appwindow;
	struct Screen *pubscreen;
	struct MsgPort *appmsgport;	
	struct Menu *menu;
	struct FileRequester *freq;
	
	UBYTE *logopic;						/* logo's raw chunky data */
	ULONG *logopalette;					/* logo's raw palette */

	DOUBLE aspect;						/* the screen's aspect ratio */

	struct ChunkyImage chunkypic;		/* chunky picture handle */

	struct ChunkyImage logo;			/* the logo's chunky picture handle */
	struct DisplayEntity disp;			/* a displayable unit */

	char pathname[PATHNAMESIZE];		/* some text buffers */
	char filename[FILENAMESIZE];
	char formatname[FORMATNAMESIZE];
	char windowtitle[WINDOWNAMESIZE];

	struct Hook ProgressHook;

	struct WBViewSettings settings;		/* the settings (see above) */

};


#endif
